#____________________________________________________________________________________
#
#    PersistentThreads (see README.txt for more information)
#    Copyright (C) 2002 Christoph Becker-Freyseng
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    christoph@mmc-startup.com
#    http://www.beyond-thoughts.com
#    http://www.mmc-startup.com
#____________________________________________________________________________________
#




__doc__="""Constants for PersistentThreads"""
__version__='0.1.1'


# The ID of this product
product_id= 'PersistentThreads'

# the kay that will be added to the context-dictionary of this product, so that PersistentThreads will be able to store data as it's value
persistent_threads_id= '_persistent_threads'

# The Label for PPHandler, viewing this site you can check if your user will be able to access it and make PThreading (see help)
ppHandler_label= 'PPHandler-Check'

# This action is automagically called to trigger PThreads via PPHandler
ppHandler_action= 'ppHandlerTrigger'

# The permission to Trigger PPHandler
ppHandler_permission= 'Trigger PPHandler'

# The location in Zopes acquisition-tree where PPHandlers trigger can be found
ppHandlerLocation= '/Control_Panel/Products/'+product_id+'/'+ppHandler_action

# the URL where the PPHandler can be triggered
ppHandlerURL= 'http://localhost:8080' + ppHandlerLocation

# The Label for PThreadTool
pThreadTool_label= 'Threads'

# The Action for PThreadTool
pThreadTool_action= 'doHandleThreadTool'

# The permission to use the PThreadTool
pThreadTool_permission= 'Use PThreadTool'



