#____________________________________________________________________________________
#
#    PersistentThreads (see README.txt for more information)
#    Copyright (C) 2002 Christoph Becker-Freyseng
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    christoph@mmc-startup.com
#    http://www.beyond-thoughts.com
#    http://www.mmc-startup.com
#____________________________________________________________________________________
#



__doc__="""PThreadTool a simple management-interface for PThreads"""
__version__='0.1.1'


from PConstants import pThreadTool_label, pThreadTool_action, pThreadTool_permission
import PTTools
from PTTools import checkPermission, wrapHTML
import PPManager


from DocumentTemplate.DT_Var import html_quote, url_quote, url_quote_plus

import time




def initPThreadTool(prodP):
    try:
	pToolD= getattr(prodP, pThreadTool_action, None)
    except:
        pToolD= None
    if pToolD is None:
	setattr(prodP, pThreadTool_action, threadToolHandler)
	prodP.manage_options = prodP.manage_options + ({
	    'label':pThreadTool_label, 'action':pThreadTool_action,
	},)
	prodP._p_changed= 1
	get_transaction().note('Added a "'+str(pThreadTool_action)+'" to the "'+str(prodP)+'" Product')
	get_transaction().commit()





def threadToolHandler(self, doCommand=None, doCmdPTID=None, REQUEST=None):
    """ A Tool to help you to see the PThreads running, inspecting their data, ..."""
    import time		# Whaaaaa. When I assign this Func into the management-screens it looses previously imported modules
    pChkD= checkPermission(pThreadTool_permission, self, REQUEST)         # Whaaa, Zope just didn't make it right
    if (pChkD is not None):
	return str(pChkD)
    strD= ''
    strD=strD+ '<a href="?"><h1>Threads</h1></a>'
    ppManD= PPManager._getPPMan(self)
    if doCommand == 'stop':
	if doCmdPTID is not None: ppManD.stopPP(doCmdPTID)
    elif doCommand == 'start':
	if doCmdPTID is not None: ppManD.startPP(doCmdPTID, delayP=1.0)
    elif doCommand == 'del':
	if doCmdPTID is not None: ppManD.delPP(doCmdPTID)
    elif (doCommand == 'new') and (REQUEST is not None):
	str2D= ''
	idD= str(getattr(REQUEST, 'pThreadTool_ppID', ''))
        ppNameD= str(getattr(REQUEST, 'pThreadTool_ppName', ''))
        ppClassD= PTTools.getUI_PP(ppNameD)
        if ppClassD is None:
            strD=strD+ '<h2>Error: "' + ppNameD + '" is not registered</h2>\n'
        else:
            ppD= ppClassD()
            initStatD= ppD.getUI_init(REQUEST)
            if initStatD is None:
                if idD:
                    if ppManD.statusPP(idD) is not None:
                        str2D=str2D+ '<h2>Error: "' + idD + '" exists already</h2>\n'
                    else:
                        ppManD.addPP(idD, ppD)
                else:
                    str2D=str2D+ '<h2>Error: You must enter an id</h2>\n'
            else:
                str2D=str2D+ str(initStatD)
	if str2D:
	    strD=strD+ '<hr><h2>Init PP</h2><form action="">'
	    strD=strD+ '<input type="hidden" name="doCommand" value="new"">'
	    strD=strD+ '<input type="hidden" name="pThreadTool_ppID" value="'+str(idD)+'">'
	    strD=strD+ '<input type="hidden" name="pThreadTool_ppName" value="'+str(ppNameD)+'">'
	    strD=strD+ str2D
	    strD=strD+ '<input type="submit" value=" Engage ">'
	    strD=strD+ '</form><hr><br>\n'
    elif (doCommand == 'manage') and (REQUEST is not None) and (doCmdPTID is not None):
	str2D= ''
	ppD= ppManD.getPP(doCmdPTID)
	if ppD is None:
	    str2D=str2D+ '<h2>Error: You must enter an id</h2>\n'
	else:
            manageStatD= ppD.getUI_manage(doCmdPTID, REQUEST)
            str2D=str2D+ str(manageStatD)
	if str2D:
	    strD=strD+ '<hr><h2>Manage PP</h2><form action="">'
	    strD=strD+ '<input type="hidden" name="doCommand" value="manage"">'
	    strD=strD+ '<input type="hidden" name="doCmdPTID" value="'+str(doCmdPTID)+'">'
	    strD=strD+ str2D
	    strD=strD+ '<input type="submit" value=" Engage ">'
	    strD=strD+ '</form><hr><br>\n'
##    strD=strD+ 'Time until the earliest Thread wants to run: ' + str(time.ctime(ppManD.threadMan.waitTime)) + '    ' + str(time.ctime(time.time())) + ' seconds.<br><br>\n'
    timeD= time.time()	# Cache for performance
    tmWaitTimeD= ppManD.threadMan.waitTime
    if tmWaitTimeD==0:
	strD=strD+ 'All PThreads are running right now.<br><br>\n'
    else:
	strD=strD+ 'Time until the earliest PThread wants to run: ' + str(tmWaitTimeD - timeD) + ' seconds.<br><br>\n'
    strD=strD+ """
	    <table cellpadding="2" cellspacing="2" border="1" width="100%">
            <tr>
	        <td valign="top">PThread-ID (ptID)<br></td>
		<td valign="top">Control<br></td>
		<td valign="top">Time2Wait<br></td>
		<td valign="top">User<br></td>
		<td valign="top">PThread-Object<br></td>
	    </tr>"""
    for (keyR, valueR) in ppManD._getPPDict().items():
	strD=strD+ '<tr>'
	if getattr(valueR, 'isA_UI_PProcessor', 0) == 1:
	    strD=strD+ '<td valign="top"><a href="?doCommand=manage&doCmdPTID='+str(keyR)+'">' + html_quote(str(keyR)) + '</a></td>'
	else:
	    strD=strD+ '<td valign="top">' + html_quote(str(keyR)) + '</td>' 
	valD= ppManD.statusPP(keyR)
	if valD == 0:
	    strD=strD+ '<td valign="top"><a href="?doCommand=stop&doCmdPTID=' + str(keyR) + '">Stop</a></td>'
	    strD=strD+ '<td valign="top">running</td>'
	elif valD > 0:
	    strD=strD+ '<td valign="top"><a href="?doCommand=stop&doCmdPTID=' + str(keyR) + '">Stop</a></td>'
	    strD=strD+ '<td valign="top">' + html_quote(str(valD - timeD)) + '</td>'
	elif valD == -666:
	    strD=strD+ '<td valign="top">'
	    strD=strD+ '<a href="?doCommand=start&doCmdPTID=' + str(keyR) + '">Start</a>'
	    strD=strD+ ', <a href="?doCommand=del&doCmdPTID=' + str(keyR) + '">Del</a>'
	    strD=strD+ '</td>'
	    strD=strD+ '<td valign="top">Zombie</td>'
	else:
	    strD=strD+ '<td valign="top">???</td>'
	    strD=strD+ '<td valign="top">???</td>'
	for iR in range(10):
	    str2D= ''
	    try:	# We're doing bullshit here. Always use a Manipulator to get or modify data of PPs. Here I don't do this for performance and the ability to delete a misconfigured PThread (manipulate won't work anymore)
		str2D+= '<td valign="top">' + html_quote(str(valueR.user)) + '</td>'
		str2D+= '<td valign="top">' + html_quote(str(valueR)) + '</td>'
	    except:
		str2D= ''
		import traceback, sys
		traceback.print_exc(file=sys.stderr)
		import time
		time.sleep(1.0)
	    if str2D:
		break
	if str2D:
	    strD+= str2D
	else:
	    strD+= '<td></td><td></td>'
#	strD=strD+ '<td valign="top">' + html_quote(str(valueR.user)) + '</td>'
#	strD=strD+ '<td valign="top">' + html_quote(str(valueR)) + '</td>' 
	strD=strD+ '</tr>\n'
    strD=strD+ '</table>\n'
    strD=strD+ '<br><br>\n'
    strD=strD+ '<h2>Add new PP</h2>\n'
    strD=strD+ '<form action="">'
    strD=strD+ '<b>ID: </b><input type="text" name="pThreadTool_ppID" size=40><br>'
    strD=strD+ '<input type="hidden" name="doCommand" value="new"">'
    strD=strD+ '<select size="1" name="pThreadTool_ppName">\n'
    for ppR in PTTools.registeredUI_PPs():
	strD=strD+ '<option>'+str(ppR)+'</option>\n'
    strD=strD+ '</select><br>\n'
    strD=strD+ '<input type="submit" value=" Engage ">'
    strD=strD+ '</form><br>\n'
    return wrapHTML(self, 'PThreadTool', strD, REQUEST)


